//*****************************************************************************

                // Pascal Import Unit for TinyPort

//****************************************************************************

unit tpinface;

interface

uses Windows;

Function OpenTinyPort (var Handle: THandle): DWORD; stdcall;
Function CloseTinyPort (Handle: THandle): DWORD; stdcall;
Function WriteByte (Handle: THandle; Address: DWORD; Data: Byte): DWORD; stdcall;
Function WriteWord (Handle: THandle; Address: DWORD; Data: Word): DWORD; stdcall;
Function WriteDWord (Handle: THandle; Address: DWORD; Data: DWord): DWORD;  stdcall;
Function ReadByte (Handle: THandle; Address: DWORD; var Data: Byte): DWORD;  stdcall;
Function ReadWord (Handle: THandle; Address: DWORD; var Data: Word): DWORD;  stdcall;
Function ReadDWord (Handle: THandle; Address: DWORD; var Data: DWord): DWORD;  stdcall;

{*****************************************************************************}

implementation

Function OpenTinyPort (var Handle: THandle): DWORD; stdcall;
                external 'tinypio.dll' index 1;
Function CloseTinyPort (Handle: THandle): DWORD; stdcall;
                external 'tinypio.dll' index 2;
Function WriteByte (Handle: THandle; Address: DWORD; Data: Byte): DWORD; stdcall;
                external 'tinypio.dll' index 3;
Function WriteWord (Handle: THandle; Address: DWORD; Data: Word): DWORD; stdcall;
                external 'tinypio.dll' index 4;
Function WriteDWord (Handle: THandle; Address: DWORD; Data: DWord): DWORD;  stdcall;
                external 'tinypio.dll' index 5;
Function ReadByte (Handle: THandle; Address: DWORD; var Data: Byte): DWORD;  stdcall;
                external 'tinypio.dll' index 6;
Function ReadWord (Handle: THandle; Address: DWORD; var Data: Word): DWORD;  stdcall;
                external 'tinypio.dll' index 7;
Function ReadDWord (Handle: THandle; Address: DWORD; var Data: DWord): DWORD;  stdcall;
                external 'tinypio.dll' index 8;

{*****************************************************************************}

end.


{Example: A snippet of Pascal code to read port 3e0h:

       // try to get access to the port driver; stop if error
      Result := OpenTinyPort (TinyHandle);
      if (Result <> ERROR_SUCCESS) then
        begin
        writeln (SysErrorMessage (Result));
        exit;
        end;
      .
      .
      // read a byte
      Result := ReadByte (TinyHandle, $3e0, AByte);
        if (Result <> ERROR_SUCCESS) then
              writeln (SysErrorMessage (Result));
      .
      .
      // release TinyPort
      CloseTinyPort (TinyHandle);
}
